precision mediump float;

// Data from vertex shader
varying vec2 texCoord;
varying vec3 worldNormal;
//varying vec3 worldBinormal;
//varying vec3 worldTangent;
//varying mat3 basis;
varying vec3 toLight;
varying vec3 toEye;

uniform vec4 ambient;
uniform vec4 diffuse;
uniform vec4 specular;
uniform float specularPower;
uniform bool bEnableCubemap;
uniform sampler2D base_Tex;
//uniform sampler2D bump_Tex;
//uniform samplerCube cubemap_Tex;
//uniform float bumpiness;
uniform float reflectance;

void main(void)
{
    // Get the perturbed normal, in tangent space, from the bump texture.
    //vec3 tangentSpaceNormal = texture2D(bump_Tex, texCoord).yxz * 2.0 - 1.0;

    // Smooth the tangent space normal
    //vec3 smoothNormal = vec3(0,0,1);
    //tangentSpaceNormal = tangentSpaceNormal * bumpiness + smoothNormal * (1.0-bumpiness);

    // Transform the perturbed normal from tangent space to world space
    vec3 newNormal = worldNormal; //normalize(basis * tangentSpaceNormal);

    vec4 base = texture2D( base_Tex, texCoord );

    //vec4 colorReflect = vec4(0,0,0,1);
    //vec3 reflectDir = reflect(-toEye, newNormal);
    //colorReflect = textureCube( cubemap_Tex, reflectDir );

    //vec3 colorReflectance = base.rgb*base.a*reflectance;
    //vec3 blendColor = base.rgb*(1.0-colorReflectance) + colorReflect.rgb*colorReflectance;

    float nDotL = dot(newNormal, toLight);         // Used for diffuse lighting

    vec3 maxReflect = reflect(-toLight, newNormal);
    float shine = max(dot(maxReflect, toEye), 0.0);   // Used for specular lighting

    gl_FragColor.rgb = base.rgb*ambient.rgb                                  // ambient
		//blendColor*ambient.rgb                                  // ambient
                 + base.rgb*max(nDotL, 0.0)*diffuse.rgb                              // diffuse
		 //+ blendColor*max(nDotL, 0.0)*diffuse.rgb                              // diffuse
                 //+ colorReflect*specular*base.a*reflectance                    // reflection
                 + specular.rgb*pow(shine, specularPower)*base.a; //*reflectance;  // specular
    gl_FragColor.a = base.a;
}