attribute vec4 position;
attribute vec2 uv;
attribute vec3 normal;
//attribute vec3 binormal;
//attribute vec3 tangent;

uniform mat4 matProj;
uniform mat4 matView;
uniform mat4 matWorld;
uniform mat3 matNormal;

uniform vec4 texTransform;
uniform vec3 worldLight;
uniform vec3 worldEye;

varying vec2 texCoord;
//varying mat3 basis;
varying vec3 worldNormal;
varying vec3 toLight;
varying vec3 toEye;

void main()
{
    gl_Position = matProj * matView * matWorld * position;
    texCoord = vec2(uv.x*texTransform.x + texTransform.y, uv.y*texTransform.z + texTransform.w);
    worldNormal   = normalize(matNormal * normal);
    //vec3 worldBinormal = normalize(matNormal * binormal);
    //vec3 worldTangent  = normalize(matNormal * tangent);
    
    //basis = mat3(worldBinormal, worldTangent, worldNormal);

    // Get a vector to the light in world coordinates
    vec4 posWorld = matWorld * position;
    toLight = normalize(worldLight - posWorld.xyz);
    toEye = normalize(worldEye - posWorld.xyz);
}